//+------------------------------------------------------------------+
//|              MTF Divergences search for different Indicators.mq4 |
//|              Copyright 2016, Artem A. Trishkin, Skype artmedia70 |
//|                       https://login.mql5.com/ru/users/artmedia70 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, Artem A. Trishkin, Skype artmedia70"
#property link      "https://login.mql5.com/ru/users/artmedia70"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_plots   6
//--- plot AoUP
#property indicator_label1  "AO Sell Signal"
#property indicator_type1   DRAW_ARROW
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- plot AoDN
#property indicator_label2  "AO Buy Signal"
#property indicator_type2   DRAW_ARROW
#property indicator_color2  clrDodgerBlue
#property indicator_style2  STYLE_SOLID
#property indicator_width2  1
//--- plot MacdUP
#property indicator_label3  "MACD Sell Signal"
#property indicator_type3   DRAW_ARROW
#property indicator_color3  clrRed
#property indicator_style3  STYLE_SOLID
#property indicator_width3  1
//--- plot MacdDN
#property indicator_label4  "MACD Buy Signal"
#property indicator_type4   DRAW_ARROW
#property indicator_color4  clrDodgerBlue
#property indicator_style4  STYLE_SOLID
#property indicator_width4  1
//---
//--- plot S-RoC UP
#property indicator_label5  "S-RoC Sell Signal"
#property indicator_type5   DRAW_ARROW
#property indicator_color5  clrRed
#property indicator_style5  STYLE_SOLID
#property indicator_width5  1
//--- plot S-RoC DN
#property indicator_label6  "S-RoC Buy Signal"
#property indicator_type6   DRAW_ARROW
#property indicator_color6  clrDodgerBlue
#property indicator_style6  STYLE_SOLID
#property indicator_width6  1

//--- indicator buffers
double         BufferAoUP[];
double         BufferAoDN[];
double         BufferMacdUP[];
double         BufferMacdDN[];
//---
double         BufferRocUP[];
double         BufferRocDN[];
//+------------------------------------------------------------------+
//|  Enums                                                           |
//+------------------------------------------------------------------+
enum enumYN
  {
   enYes=1, // 
   enNo=0,  // 
  };
enum enumModeLINE
  {
   enMdMain=MODE_MAIN,  // Main
   enMdSign=MODE_SIGNAL,// Signal
  };
enum enumCoincidence
  {
   enCoinAccurate=1,    // 
   enCoinApproximate=0, // 
  };
//+------------------------------------------------------------------+
//|  Input Variables                                                 |
//+------------------------------------------------------------------+
extern string  Div_Params = "--    --";//======================================
sinput   ENUM_TIMEFRAMES   PeriodForWork=PERIOD_H4;               // ,    
ENUM_TIMEFRAMES periodForWork; // ,    
sinput   enumCoincidence   SearchAccuracy=enCoinApproximate;      //       
input    int               NumBarAccuracy=3;                      //        
int numBarAccuracy; //     
input    int               KoeffDistanceBetween=5;                //  ""  
double koeffForDistanceBetween; //  ""  
sinput   int               WidthChartLine=1;                      //     
int widthChartLine; //     
sinput   ENUM_LINE_STYLE   StyleChartLine=STYLE_SOLID;            //     
sinput   int               WidthIndicatorsLine=1;                 //     
int widthIndicatorsLine; //     
sinput   ENUM_LINE_STYLE   StyleIndicatorsLine=STYLE_SOLID;       //     

//---  
extern string  AO_Params = "--  AO --";//======================================
sinput   enumYN            UseAO=enYes;                           //    AO
sinput   color             ColorUpperAO=clrRed;                   //     AO
sinput   color             ColorLowerAO=clrBlue;                  //     AO

extern string  MACD_Params = "--  MACD --"; //======================================
sinput   enumYN            UseMACD=enNo;                          //    MACD
input    enumModeLINE      ModeLineMACD=enMdMain;                 //     MACD:
input    int               FastEMA_MACD=12;                       //  EMA MACD
int fastEMA_MACD; //  EMA MACD
input    int               SlowEMA_MACD=26;                       //  EMA MACD
int slowEMA_MACD; //  EMA MACD
input    int               PeriodSignalMACD=9;                    //   SMA MACD
int periodSignalMACD; //   SMA MACD
input    ENUM_APPLIED_PRICE AppledPriceMACD=PRICE_CLOSE;          //  :
sinput   color             ColorUpperMACD=clrRed;                 //     MACD
sinput   color             ColorLowerMACD=clrBlue;                //     MACD

extern string  RoC_Params = "--  S-RoC --";//======================================
sinput   enumYN            UseRoC=enYes;                          //    S-RoC
sinput   string            NameRoC="S-RoC";                       //    S-RoC
input    int               PeriodEMA_RoC=13;                      //  EMA S-RoC
int periodEMA_RoC;
input    int               PeriodRoC=21;                          //   (S-RoC)
int periodRoC;
sinput   color             ColorUpperRoC=clrRed;                  //     S-RoC
sinput   color             ColorLowerRoC=clrBlue;                 //     S-RoC

//+------------------------------------------------------------------+
//|  Global Variables                                                |
//+------------------------------------------------------------------+
string Prefix, symbol;
int    number_ao;       //   AO
int    number_macd;     //   MACD
int    number_roc;      //   S-RoC

string name_ao="";
string name_macd="";
string name_roc="";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,BufferAoUP);          //    "" AO
   SetIndexBuffer(1,BufferAoDN);          //    "" AO
   SetIndexBuffer(2,BufferMacdUP);        //    "" MACD
   SetIndexBuffer(3,BufferMacdDN);        //    "" MACD
   //---
   SetIndexBuffer(4,BufferRocUP);        //    "" S-RoC
   SetIndexBuffer(5,BufferRocDN);        //    "" S-RoC
//--- setting a code from the Wingdings charset as the property of PLOT_ARROW
   //--- mql5
   PlotIndexSetInteger(0,PLOT_ARROW,234); //  ""   . AO
   PlotIndexSetInteger(1,PLOT_ARROW,233); //  ""   . AO
   PlotIndexSetInteger(2,PLOT_ARROW,234); //  ""   . MACD
   PlotIndexSetInteger(3,PLOT_ARROW,233); //  ""   . MACD
   //---
   PlotIndexSetInteger(4,PLOT_ARROW,234); //  ""   . S-RoC
   PlotIndexSetInteger(5,PLOT_ARROW,233); //  ""   . S-RoC
   //--- mql4
   SetIndexArrow(0,242);                  //  ""   . AO
   SetIndexArrow(1,241);                  //  ""   . AO
   SetIndexArrow(2,248);                  //  ""   . MACD
   SetIndexArrow(3,246);                  //  ""   . MACD
   //---
   SetIndexArrow(4,248);                  //  ""   . S-RoC
   SetIndexArrow(5,246);                  //  ""   . S-RoC
   //---  
   ArrayInitialize(BufferAoDN,EMPTY_VALUE);
   ArrayInitialize(BufferAoUP,EMPTY_VALUE);
   ArrayInitialize(BufferMacdDN,EMPTY_VALUE);
   ArrayInitialize(BufferMacdUP,EMPTY_VALUE);
   //---
   ArrayInitialize(BufferRocDN,EMPTY_VALUE);
   ArrayInitialize(BufferRocUP,EMPTY_VALUE);
   //--- 
   symbol=Symbol();
   Prefix="MTFdiv";                      //   
   IndicatorSetString(INDICATOR_SHORTNAME,Prefix); //   
   //---    MACD
   fastEMA_MACD=(FastEMA_MACD<1)?1:FastEMA_MACD;                           //     1,  1,   
   slowEMA_MACD=(SlowEMA_MACD<=fastEMA_MACD)?fastEMA_MACD+1:SlowEMA_MACD;  //    ,     (   ),   +1,   
   periodSignalMACD=(PeriodSignalMACD<1)?1:PeriodSignalMACD;
   //---    S-RoC
   periodEMA_RoC=(PeriodEMA_RoC<1?1:PeriodEMA_RoC);
   periodRoC=(PeriodRoC<1?1:PeriodRoC);
   //---  
   numBarAccuracy=(NumBarAccuracy<0)?0:NumBarAccuracy;
   if(SearchAccuracy) numBarAccuracy=1;
   //   ""  
   koeffForDistanceBetween=(KoeffDistanceBetween<0)?0:KoeffDistanceBetween*Point();
   //---      ,      
   periodForWork=PeriodForWork;
   if(Period()>periodForWork) {
      Alert("   : ",GetNameTF(PeriodForWork),"\n    ",GetNameTF(Period()));
      periodForWork=PERIOD_CURRENT;//GetTFasEnum(Period());
      }
   //---  
   widthChartLine=(WidthChartLine<1)?1:WidthChartLine;
   widthIndicatorsLine=(WidthIndicatorsLine<1)?1:WidthIndicatorsLine;
   //---  
   number_ao=0;
   number_macd=1;
   number_roc=2;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- delete graphics
   ObjectsDeleteAll(0,Prefix);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   if(rates_total<koeffForDistanceBetween*2) return(0);
   //---
   double ao_a, ao_b, ao_c;
   double macd_a, macd_b, macd_c;
   double roc_a, roc_b, roc_c;
   int limit=rates_total-prev_calculated;
   if(limit>1) {
      limit=rates_total-4;
      }
   name_ao="AO";
   name_macd="MACD("+(string)fastEMA_MACD+","+(string)slowEMA_MACD+","+(string)periodSignalMACD+")";
   name_roc=NameRoC+"("+(string)periodEMA_RoC+", "+(string)periodRoC+")";
   
   int wnd_ao=GetWindowNumber(name_ao);      //    AO
   int wnd_macd=GetWindowNumber(name_macd);  //    MACD
   int wnd_roc=GetWindowNumber(name_roc);    //    S-RoC

   int periodSeconds=PeriodSeconds(periodForWork); //     
   static datetime lastTime=0;
   //---   
   for(int i=limit; i>=0; i--) {
      datetime timePeriod=GetTimeOpen(symbol,periodForWork,i); //      ,    i   
      if(timePeriod>0 && timePeriod>lastTime) {  //         (   )
         //---
         int bar_a=GetBarShift(symbol,periodForWork,timePeriod-2*periodSeconds); //        
         int bar_b=GetBarShift(symbol,periodForWork,timePeriod-periodSeconds);   //        
         int bar_c=GetBarShift(symbol,periodForWork,timePeriod);                 //        
         
         datetime time_a=GetTimeOpen(symbol,periodForWork,i+2);                  //        
         datetime time_b=GetTimeOpen(symbol,periodForWork,i+1);                  //        
         datetime time_c=GetTimeOpen(symbol,periodForWork,i);                    //        
         
         //+------------------------------------------------------------------+
         //| -     AO                                   |
         //+------------------------------------------------------------------+
         if(UseAO) {
            ao_a=GetDataAO(symbol,periodForWork,bar_a);           //     
            ao_b=GetDataAO(symbol,periodForWork,bar_b);           //     B
            ao_c=GetDataAO(symbol,periodForWork,bar_c);           //     C
            //---          
            int extrAO=GetDirectionExtremum(ao_a,ao_b,ao_c);
            //---       AO  
            static double     lastUpAO_extrValue=0;            //     AO (   )
            static double     lastDnAO_extrValue=0;            //     AO (   )
            //---
            static double     leftAO_UP=0;                     //     AO   
            static double     leftAO_DN=0;                     //     AO   
            static datetime   leftAO_tUP=0;                    //     AO   
            static datetime   leftAO_tDN=0;                    //     AO   
            //---
            static double     lastUpPrcAO_extrValue=0;         //       AO
            static datetime   lastUpPrcAO_extrTime=0;          //       AO
            static double     lastDnPrcAO_extrValue=0;         //       AO
            static datetime   lastDnPrcAO_extrTime=0;          //       AO
            //---     AO ( )
            if(extrAO==OP_BUY) {
               //---     AO  ,    
               if(ao_b<0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_BUY,ao_b,bar_b,wnd_ao,time_b,time,i,leftAO_tUP,leftAO_UP,leftAO_tDN,leftAO_DN,lastUpAO_extrValue,lastDnAO_extrValue,lastUpPrcAO_extrValue,lastUpPrcAO_extrTime,lastDnPrcAO_extrValue,lastDnPrcAO_extrTime,rates_total,BufferAoUP,BufferAoDN);
                  }
               lastDnAO_extrValue=ao_b;  //   ""   AO       AO (   )
               }
            //---     AO ( )
            if(extrAO==OP_SELL) {
               //---     AO  ,    
               if(ao_b>0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_SELL,ao_b,bar_b,wnd_ao,time_b,time,i,leftAO_tUP,leftAO_UP,leftAO_tDN,leftAO_DN,lastUpAO_extrValue,lastDnAO_extrValue,lastUpPrcAO_extrValue,lastUpPrcAO_extrTime,lastDnPrcAO_extrValue,lastDnPrcAO_extrTime,rates_total,BufferAoUP,BufferAoDN);
                  }
               lastUpAO_extrValue=ao_b;  //   ""   AO       AO (   )
               }
            }  //---   AO
         
         //+------------------------------------------------------------------+
         //| -     MACD                                 |
         //+------------------------------------------------------------------+
         if(UseMACD) {
            macd_a=GetDataMACD(symbol,periodForWork,ModeLineMACD,bar_a);         //  MACD   
            macd_b=GetDataMACD(symbol,periodForWork,ModeLineMACD,bar_b);         //  MACD   B
            macd_c=GetDataMACD(symbol,periodForWork,ModeLineMACD,bar_c);         //  MACD   C
            //---  MACD        
            int extrMACD=GetDirectionExtremum(macd_a,macd_b,macd_c);
            //---       MACD  
            static double     lastUpMACD_extrValue=0;          //     MACD (   )
            static double     lastDnMACD_extrValue=0;          //     MACD (   )
            //---
            static double     leftMACD_UP=0;                   //     MACD   
            static double     leftMACD_DN=0;                   //     MACD   
            static datetime   leftMACD_tUP=0;                  //     MACD   
            static datetime   leftMACD_tDN=0;                  //     MACD   
            //---
            static double     lastUpPrcMACD_extrValue=0;       //       MACD
            static datetime   lastUpPrcMACD_extrTime=0;        //       MACD
            static double     lastDnPrcMACD_extrValue=0;       //       MACD
            static datetime   lastDnPrcMACD_extrTime=0;        //       MACD
            //---     MACD ( )
            if(extrMACD==OP_BUY) {
               //---     MACD  ,    
               if(macd_b<0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_BUY,macd_b,bar_b,wnd_macd,time_b,time,i,leftMACD_tUP,leftMACD_UP,leftMACD_tDN,leftMACD_DN,lastUpMACD_extrValue,lastDnMACD_extrValue,lastUpPrcMACD_extrValue,lastUpPrcMACD_extrTime,lastDnPrcMACD_extrValue,lastDnPrcMACD_extrTime,rates_total,BufferMacdUP,BufferMacdDN);
                  }
               lastDnMACD_extrValue=macd_b;  //   ""   MACD       MACD (   )
               }
            //---     MACD ( )
            if(extrMACD==OP_SELL) {
               //---     MACD  ,    
               if(macd_b>0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_SELL,macd_b,bar_b,wnd_macd,time_b,time,i,leftMACD_tUP,leftMACD_UP,leftMACD_tDN,leftMACD_DN,lastUpMACD_extrValue,lastDnMACD_extrValue,lastUpPrcMACD_extrValue,lastUpPrcMACD_extrTime,lastDnPrcMACD_extrValue,lastDnPrcMACD_extrTime,rates_total,BufferMacdUP,BufferMacdDN);
                  }
               lastUpMACD_extrValue=macd_b;  //   ""   MACD       MACD (   )
               }
            }  //---   MACD
         
         //+------------------------------------------------------------------+
         //| -     S-RoC                                |
         //+------------------------------------------------------------------+
         if(UseRoC) {
            roc_a=GetDataRoC(symbol,periodForWork,bar_a);      //  S-RoC   
            roc_b=GetDataRoC(symbol,periodForWork,bar_b);      //  S-RoC   B
            roc_c=GetDataRoC(symbol,periodForWork,bar_c);      //  S-RoC   C
            //---  S-RoC        
            int extrRoC=GetDirectionExtremum(roc_a,roc_b,roc_c);
            //---       S-RoC  
            static double     lastUpRoC_extrValue=0;          //     S-RoC (   )
            static double     lastDnRoC_extrValue=0;          //     S-RoC (   )
            //---
            static double     leftRoC_UP=0;                   //     S-RoC   
            static double     leftRoC_DN=0;                   //     S-RoC   
            static datetime   leftRoC_tUP=0;                  //     S-RoC   
            static datetime   leftRoC_tDN=0;                  //     S-RoC   
            //---
            static double     lastUpPrcRoC_extrValue=0;       //       S-RoC
            static datetime   lastUpPrcRoC_extrTime=0;        //       S-RoC
            static double     lastDnPrcRoC_extrValue=0;       //       S-RoC
            static datetime   lastDnPrcRoC_extrTime=0;        //       S-RoC
            //---     S-RoC ( )
            if(extrRoC==OP_BUY) {
               //---     S-RoC  ,    
               if(roc_b<0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_BUY,roc_b,bar_b,wnd_roc,time_b,time,i,leftRoC_tUP,leftRoC_UP,leftRoC_tDN,leftRoC_DN,lastUpRoC_extrValue,lastDnRoC_extrValue,lastUpPrcRoC_extrValue,lastUpPrcRoC_extrTime,lastDnPrcRoC_extrValue,lastDnPrcRoC_extrTime,rates_total,BufferRocUP,BufferRocDN);
                  }
               lastDnRoC_extrValue=roc_b;  //   ""   S-RoC       S-RoC (   )
               }
            //---     S-RoC ( )
            if(extrRoC==OP_SELL) {
               //---     S-RoC  ,    
               if(roc_b>0) {
                  FindAndSetDivergence(symbol,periodForWork,OP_SELL,roc_b,bar_b,wnd_roc,time_b,time,i,leftRoC_tUP,leftRoC_UP,leftRoC_tDN,leftRoC_DN,lastUpRoC_extrValue,lastDnRoC_extrValue,lastUpPrcRoC_extrValue,lastUpPrcRoC_extrTime,lastDnPrcRoC_extrValue,lastDnPrcRoC_extrTime,rates_total,BufferRocUP,BufferRocDN);
                  }
               lastUpRoC_extrValue=roc_b;  //   ""   S-RoC       S-RoC (   )
               }
            }  //---   S-RoC
         
         //---    
         lastTime=timePeriod; //          
         }
      //---   
      }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Functions                                                        |
//+------------------------------------------------------------------+
void FindAndSetDivergence(string symbol_name, ENUM_TIMEFRAMES work_period, int direct_extr,
                          double ind_b, int bar_b, int wnd, datetime time_b, const datetime &time[], int index,
                          datetime &left_time_up, double &left_point_up, datetime &left_time_dn, double &left_point_dn,
                          double &last_up_ind, double &last_dn_ind, double &last_up_prc_val, datetime &last_up_prc_tm, double &last_dn_prc_val, datetime &last_dn_prc_tm,
                          const int &rates_total, double &BufferUP[], double &BufferDN[]) {
   
   string name_ind=(wnd==GetWindowNumber(name_ao)?"AO":wnd==GetWindowNumber(name_macd)?"MACD":"S-RoC");
   Comment("\nName Ind=",name_ind,", wnd=",wnd,", GetWindowNumber(name_roc)=",GetWindowNumber(name_roc));
   if(direct_extr==OP_BUY) {
      //---         
      double distance=fabs(last_up_ind-ind_b);
      //---       
      if(NormalizeDouble(distance-koeffForDistanceBetween,Digits()+1)>0) {
         //---   
         int bar_extr=EMPTY;  //    
         datetime time_extr=0;//    
         double price_extr=0; //    
         MqlRates array[];    //       
         int num_extr=GetExtremumsLower(symbol_name,work_period,rates_total,bar_b,array);
         //---   
         if(num_extr>0) {
            price_extr=array[0].low;
            time_extr=array[0].time;
            //---       
            for(int k=1; k<num_extr; k++) {
               if(array[k].low<price_extr && array[k].low>0) {
                  price_extr=array[k].low;
                  time_extr=array[k].time;
                  }
               }
            }
         //---    
         if(price_extr>0) {
            //---       ,   
            if(work_period!=Period()) {
               datetime timeStart=time_extr; //     
               //---       
               datetime timeStop=timeStart+PeriodSeconds(work_period)-PeriodSeconds(PERIOD_CURRENT);
               MqlRates rt[];
               int sz=CopyRates(symbol_name,PERIOD_CURRENT,timeStart,timeStop,rt);
               //---    
               for(int k=0; k<sz; k++) {
                  if(NormalizeDouble(rt[k].low-price_extr,8)==0) {
                     time_extr=rt[k].time;
                     break;
                     }
                  }
               }
            //---          ()
            if(last_dn_prc_val<price_extr && left_point_dn>ind_b) {
               SetDivergenceDN(symbol_name,work_period,wnd,name_ind,"",time,index,left_time_dn,left_point_dn,time_b,ind_b,last_dn_prc_tm,last_dn_prc_val,time_extr,price_extr,BufferDN);
               }
            //---          ()
            if(last_dn_prc_val>price_extr && left_point_dn<ind_b) {
               SetDivergenceDN(symbol_name,work_period,wnd,name_ind,"",time,index,left_time_dn,left_point_dn,time_b,ind_b,last_dn_prc_tm,last_dn_prc_val,time_extr,price_extr,BufferDN);
               }
            last_dn_prc_val=price_extr; //     
            last_dn_prc_tm=time_extr;   //     
            }
         //---      
         left_point_dn=ind_b;
         left_time_dn=time_b;
         }
      }
   //---     ( )
   if(direct_extr==OP_SELL) {
      //---         
      double distance=fabs(last_dn_ind-ind_b);
      //---       
      if(NormalizeDouble(distance-koeffForDistanceBetween,Digits()+1)>0) {
         //---   
         int bar_extr=EMPTY;  //   
         datetime time_extr=0;//   
         double price_extr=0; //   
         MqlRates array[];
         int num_extr=GetExtremumsUpper(symbol_name,work_period,rates_total,bar_b,array);
         if(num_extr>0) {
            price_extr=array[0].high;
            time_extr=array[0].time;
            for(int k=1; k<num_extr; k++) {
               if(array[k].high>price_extr) {
                  price_extr=array[k].high;
                  time_extr=array[k].time;
                  }
               }
            }
         //---    
         if(price_extr>0) {
            //---       ,   
            if(work_period!=Period()) {
               datetime timeStart=time_extr; //     
               //---       
               datetime timeStop=timeStart+PeriodSeconds(work_period)-PeriodSeconds(PERIOD_CURRENT);
               MqlRates rt[];
               int sz=CopyRates(symbol_name,PERIOD_CURRENT,timeStart,timeStop,rt);
               ArraySetAsSeries(rt,true);
               //---    
               for(int k=0; k<sz; k++) {
                  if(NormalizeDouble(rt[k].high-price_extr,8)==0) {
                     time_extr=rt[k].time;
                     break;
                     }
                  }
               }
            //---          ()
            if(last_up_prc_val<price_extr && left_point_up>ind_b) {
               SetDivergenceUP(symbol_name,work_period,wnd,name_ind,"",time,index,left_time_up,left_point_up,time_b,ind_b,last_up_prc_tm,last_up_prc_val,time_extr,price_extr,BufferUP);
               }
            if(last_up_prc_val>price_extr && left_point_up<ind_b) {
               SetDivergenceUP(symbol_name,work_period,wnd,name_ind,"",time,index,left_time_up,left_point_up,time_b,ind_b,last_up_prc_tm,last_up_prc_val,time_extr,price_extr,BufferUP);
               }
            last_up_prc_val=price_extr; //     
            last_up_prc_tm=time_extr;   //     
            }
         //---      
         left_point_up=ind_b;
         left_time_up=time_b;
         }
      }
}
//+------------------------------------------------------------------+
void SetDivergenceDN(string symbol_name, int work_period, int wnd, string name_ind, string pattern, const datetime &time[], int index,
                     datetime left_time, double left_point, datetime time_b, double ind_b, 
                     datetime last_prc_tm, double last_prc_val, datetime time_extr, double price_extr, double &Buffer[]) {
   color line_color=clrNONE;
   string nm="";
   line_color=(name_ind=="AO"?ColorLowerAO:name_ind=="MACD"?ColorLowerMACD:ColorLowerRoC);
   //---      
   int bar_extr=GetBarShift(symbol_name,PERIOD_CURRENT,time_extr);
   Buffer[bar_extr]=GetPriceLow(symbol_name,PERIOD_CURRENT,bar_extr);
   //---      
   int last_bar_extr=GetBarShift(symbol_name,PERIOD_CURRENT,last_prc_tm);
   nm=Prefix+"P"+name_ind+"divLower"+TimeToString(time_b);
   SetTLine(0,nm,line_color,0,last_prc_tm,last_prc_val,time_extr,price_extr,widthChartLine,pattern+" "+name_ind+(work_period==Period()?"":"\n  "+GetNameTF(work_period)),StyleChartLine);
   //---    ,      
   if(wnd>0) {
      nm=Prefix+name_ind+"divLower"+TimeToString(time_b);
      SetTLine(0,nm,line_color,wnd,left_time,left_point,time_b,ind_b,widthIndicatorsLine,pattern+" "+(work_period==Period()?"":"\n  "+GetNameTF(work_period)),StyleIndicatorsLine);
      }
}
//+------------------------------------------------------------------+
void SetDivergenceUP(string symbol_name, int work_period, int wnd, string name_ind, string pattern, const datetime &time[], int index,
                     datetime left_time, double left_point, datetime time_b, double ind_b, 
                     datetime last_prc_tm, double last_prc_val, datetime time_extr, double price_extr, double &Buffer[]) {
   color line_color=clrNONE;
   string nm="";
   line_color=(name_ind=="AO"?ColorUpperAO:name_ind=="MACD"?ColorUpperMACD:ColorUpperRoC);
   //---      
   int bar_extr=GetBarShift(symbol_name,PERIOD_CURRENT,time_extr);
   Buffer[bar_extr]=GetPriceHigh(symbol_name,PERIOD_CURRENT,bar_extr);
   //---      
   int last_bar_extr=GetBarShift(symbol_name,PERIOD_CURRENT,last_prc_tm);
   nm=Prefix+"P"+name_ind+"divUpper"+TimeToString(time_b);
   SetTLine(0,nm,line_color,0,last_prc_tm,last_prc_val,time_extr,price_extr,widthChartLine,pattern+" "+name_ind+(work_period==Period()?"":"\n  "+GetNameTF(work_period)),StyleChartLine);
   //---    ,      
   if(wnd>0) {
      nm=Prefix+name_ind+"divUpper"+TimeToString(time_b);
      SetTLine(0,nm,line_color,wnd,left_time,left_point,time_b,ind_b,widthIndicatorsLine,pattern+" "+(work_period==Period()?"":"\n  "+GetNameTF(work_period)),StyleIndicatorsLine);
      }
}
//+------------------------------------------------------------------+
double GetDataAO(string symbol_name, int timeframe, int shift) {
   return(iAO(symbol_name,timeframe,shift));
}
//+------------------------------------------------------------------+
double GetDataMACD(string symbol_name, int timeframe, int mode, int shift) {
   return(iMACD(symbol_name,timeframe,fastEMA_MACD,slowEMA_MACD,periodSignalMACD,AppledPriceMACD,mode,shift));
}
//+------------------------------------------------------------------+
double GetDataRoC(string symbol_name, int timeframe, int shift) {
   return(iCustom(symbol_name,timeframe,NameRoC,periodEMA_RoC,periodRoC,0,shift));
}
//+------------------------------------------------------------------+
int GetExtremumsUpper(string symbol_name, ENUM_TIMEFRAMES timeframe, const int &total, int bar_b, MqlRates &array[]) {
   int bars=Bars(symbol_name,timeframe);
   int total_tf=fmin(total,bars);
   int begin=bar_b-numBarAccuracy;     //  ,      
   if(begin<1) begin=1;                //   begin       
   int end=begin+numBarAccuracy*2;     //  ,      
   if(end>total_tf-2) end=total_tf-2;  //   end       
   int count=end-begin;                //  ,     
   //---
   int n=0;
   ArrayResize(array,n,numBarAccuracy*2);
   //---       array
   for(int j=begin; j<=end; j++) {
      if(j>total_tf-2) break;
      double a=GetPriceHigh(symbol_name,timeframe,j+1);
      double b=GetPriceHigh(symbol_name,timeframe,j);
      double c=GetPriceHigh(symbol_name,timeframe,j-1);
      int extr=GetDirectionExtremum(a,b,c);
      if(extr==OP_SELL) {
         n++; ArrayResize(array,n);
         array[n-1].high=b;
         array[n-1].close=GetPriceClose(symbol_name,timeframe,j);
         array[n-1].time=GetTimeOpen(symbol_name,timeframe,j);
         }
      }
   //---       ,        count
   if(ArraySize(array)==0) {
      ArrayResize(array,1);   //    array  1
      MqlRates data[];        //          count
      if(CopyRates(symbol_name,timeframe,begin,count,data)>0) {
         double max=data[0].high;
         datetime t=data[0].time;
         for(int j=1; j<ArraySize(data); j++) {
            if(data[j].high>max) {
               max=data[j].high;
               t=data[j].time;
               }
            }
         array[0].high=max;
         array[0].time=t;
         }
      }
   return(ArraySize(array));
}
//+------------------------------------------------------------------+
int GetExtremumsLower(string symbol_name, ENUM_TIMEFRAMES timeframe, const int &total, int bar_b, MqlRates &array[]) {
   int bars=Bars(symbol_name,timeframe);
   int total_tf=fmin(total,bars);
   int begin=bar_b-numBarAccuracy;     //  ,      
   if(begin<1) begin=1;                //   begin       
   int end=begin+numBarAccuracy*2;     //  ,      
   if(end>total_tf-2) end=total_tf-2;  //   end       
   int count=(end-begin)+1;            //  ,     
   //---
   int n=0;
   ArrayResize(array,n,numBarAccuracy*2);
   for(int j=begin; j<=end; j++) {
      if(j>total_tf-2) break;
      double a=GetPriceLow(symbol_name,timeframe,j+1);
      double b=GetPriceLow(symbol_name,timeframe,j);
      double c=GetPriceLow(symbol_name,timeframe,j-1);
      int extr=GetDirectionExtremum(a,b,c);
      if(extr==OP_BUY) {
         n++; ArrayResize(array,n);
         array[n-1].low=b;
         array[n-1].close=GetPriceClose(symbol_name,timeframe,j);
         array[n-1].time=GetTimeOpen(symbol_name,timeframe,j);
         }
      }
   //---       ,        count
   if(ArraySize(array)==0) {
      ArrayResize(array,1);   //    array  1
      MqlRates data[];        //          count
      if(CopyRates(symbol_name,timeframe,begin,count,data)>0) {
         double min=data[0].low;
         datetime t=data[0].time;
         for(int j=1; j<ArraySize(data); j++) {
            if(data[j].low<min) {
               min=data[j].low;
               t=data[j].time;
               }
            }
         array[0].low=min;
         array[0].time=t;
         }
      }
   return(ArraySize(array));
}
//+------------------------------------------------------------------+
int GetDirectionExtremum(double a, double b, double c, bool null_flag=true) {
   //---      
   if(null_flag) {
      if((a-b)*(b-c)<0) {
         if(c>b) return(OP_BUY);
         if(c<b) return(OP_SELL);
         }
      }
   //---      
   else {
      if((a>b && b<=c)/* || (a>=b && b<c)*/) return(OP_BUY);
      if((a<b && b>=c)/* || (a<=b && b>c)*/) return(OP_SELL);
      }
   return(EMPTY);
}
//+------------------------------------------------------------------+
int GetWindowNumber(string name="") {
   return(WindowFind(name));
}
//+------------------------------------------------------------------+
void SetTLine(const long chart_id, const string name, color line_color, const int sub_window,
              datetime line_time1, double line_price1, datetime line_time2, double line_price2, int line_width=1,
              string tooltip="\n", int line_style=STYLE_SOLID, bool line_ray_right=false, bool line_ray_left=false, 
              string line_text="", bool selection=false, bool hidden=true) {
   
   if(ObjectFind(chart_id,name)<0) ObjectCreate(chart_id, name, OBJ_TREND, sub_window, 0, 0, 0, 0);
   ObjectSetInteger(chart_id,name,OBJPROP_TIME1,line_time1);
   ObjectSetDouble(chart_id,name,OBJPROP_PRICE1,line_price1);
   ObjectSetInteger(chart_id,name,OBJPROP_TIME2,line_time2);
   ObjectSetDouble(chart_id,name,OBJPROP_PRICE2,line_price2);
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,line_color);
   ObjectSetInteger(chart_id,name,OBJPROP_RAY_RIGHT,line_ray_right);
   ObjectSetInteger(chart_id,name,OBJPROP_RAY_LEFT,line_ray_left);
   ObjectSetInteger(chart_id,name,OBJPROP_STYLE,line_style);
   ObjectSetInteger(chart_id,name,OBJPROP_WIDTH,line_width);
   ObjectSetString(chart_id,name,OBJPROP_TEXT,line_text);
   ObjectSetString(chart_id,name,OBJPROP_FONT,"Tahoma");
   ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_id,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_id,name,OBJPROP_HIDDEN,hidden);
   ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,tooltip);
}
//+------------------------------------------------------------------+
datetime GetTimeOpen(string symbol_name, ENUM_TIMEFRAMES timeframe, int index) {
   datetime array[1]={-1};
   ResetLastError();
   if(CopyTime(symbol_name,timeframe,index,1,array)==1) return(array[0]);
   Print(__FUNCTION__," >     ",GetLastError());
   return(-1);
}
//+------------------------------------------------------------------+
double GetPriceOpen(string symbol_name, ENUM_TIMEFRAMES timeframe, int index) {
   double array[1]={-1};
   ResetLastError();
   if(CopyOpen(symbol_name,timeframe,index,1,array)==1) return(array[0]);
   Print(__FUNCTION__," >    Open ",GetLastError());
   return(-1);
}
//+------------------------------------------------------------------+
double GetPriceHigh(string symbol_name, ENUM_TIMEFRAMES timeframe, int index) {
   double array[1]={-1};
   ResetLastError();
   if(CopyHigh(symbol_name,timeframe,index,1,array)==1) return(array[0]);
   Print(__FUNCTION__," >    High ",GetLastError());
   return(-1);
}
//+------------------------------------------------------------------+
double GetPriceLow(string symbol_name, ENUM_TIMEFRAMES timeframe, int index) {
   double array[1]={-1};
   ResetLastError();
   if(CopyLow(symbol_name,timeframe,index,1,array)==1) return(array[0]);
   Print(__FUNCTION__," >    Low ",GetLastError());
   return(-1);
}
//+------------------------------------------------------------------+
double GetPriceClose(string symbol_name, ENUM_TIMEFRAMES timeframe, int index) {
   double array[1]={-1};
   ResetLastError();
   if(CopyClose(symbol_name,timeframe,index,1,array)==1) return(array[0]);
   Print(__FUNCTION__," >    Close ",GetLastError());
   return(-1);
}
//+------------------------------------------------------------------+
int GetBarShift(const string symbol_name, const ENUM_TIMEFRAMES timeframe, const datetime time) {
   int res=-1;
   datetime last_bar;
   if(SeriesInfoInteger(symbol_name,timeframe,SERIES_LASTBAR_DATE,last_bar)) {
      if(time>last_bar) res=0;
      else {
         const int shift=Bars(symbol_name,timeframe,time,last_bar);
         if(shift>0) res=shift-1;
         }
      }
   return(res);
}
//+------------------------------------------------------------------+
string GetNameTF(int timeframe=PERIOD_CURRENT) {
   if(timeframe==PERIOD_CURRENT) timeframe=Period();
   switch(timeframe) {
      //--- MQL4
      case 1: return("M1");
      case 5: return("M5");
      case 15: return("M15");
      case 30: return("M30");
      case 60: return("H1");
      case 240: return("H4");
      case 1440: return("D1");
      case 10080: return("W1");
      case 43200: return("MN");
      //--- MQL5
      case 2: return("M2");
      case 3: return("M3");
      case 4: return("M4");      
      case 6: return("M6");
      case 10: return("M10");
      case 12: return("M12");
      case 16385: return("H1");
      case 16386: return("H2");
      case 16387: return("H3");
      case 16388: return("H4");
      case 16390: return("H6");
      case 16392: return("H8");
      case 16396: return("H12");
      case 16408: return("D1");
      case 32769: return("W1");
      case 49153: return("MN");      
      default: return("UnknownPeriod");
   }
}
//+------------------------------------------------------------------+
